<template>
  <div class="products-home">
    <template v-if="$fetchState.pending">
      <div class="mt-10 text-center">
        <v-progress-circular :size="96" color="light-blue" class="mt-10" indeterminate></v-progress-circular>
      </div>
    </template>
    <template v-else>
      <v-container fluid class="products-home__primary">
        <v-row>
          <v-col
            v-for="(product, i) in productsPrimary"
            :key="`products-home__product-${product.id}`"
            v-anime="{ translateY: [100, 0], opacity: [0, 1], duration: 5000, delay: i * 200 }"
            class="product product--shadow"
            v-bind="productPrimaryAttrs"
            flat
          >
            <v-card flat nuxt :to="`${baseUrl}/${product.category}/${product.id}`" class="fill-height px-4 pb-3">
              <v-img
                :aspect-ratio="16 / 9"
                :min-height="350"
                :src="product.images[0].big"
                contain
                class="product__img"
              ></v-img>

              <v-card-title
                class="product__title px-8 font-weight-thin text-center"
                v-text="product.name"
              ></v-card-title>
              <v-card-subtitle class="product__price font-weight-medium black--text text-center">
                <span>{{ product.price | formattedCost }}</span> ₽
              </v-card-subtitle>
            </v-card>
          </v-col>
        </v-row>
      </v-container>

      <v-divider></v-divider>

      <v-container v-if="productsSecondary.length" fluid class="products-home__secondary mt-3">
        <v-row>
          <v-col
            v-for="(product, i) in productsSecondary"
            :key="`products-home__product-${product.id}`"
            class="product"
            v-bind="productSecondaryAttrs"
          >
            <v-card
              v-anime="{
                translateY: [300, 0],
                opacity: [0, 1],
                duration: 500,
                delay: productsPrimary.length * 200 + i * 200,
              }"
              flat
              nuxt
              :to="`${baseUrl}/${product.category}/${product.id}`"
              class="fill-height px-4"
            >
              <v-img :aspect-ratio="16 / 9" :src="product.images[0].big" contain></v-img>

              <v-card-title
                class="product__title px-8 font-weight-light body-2 text-center"
                v-text="product.name"
              ></v-card-title>
              <v-card-subtitle class="product__price font-weight-medium black--text text-center">
                <span>{{ product.price | formattedCost }}</span> ₽
              </v-card-subtitle>
            </v-card>
          </v-col>
        </v-row>
      </v-container>
    </template>
  </div>
</template>

<script>
export default {
  props: {
    primaryLimit: {
      type: Number,
      default: 4,
    },

    secondaryLimit: {
      type: Number,
      default: 12,
    },

    breakpointsPrimary: {
      type: Object,
      default: () => ({
        xs: 1,
        md: 2,
        lg: 4,
      }),
    },

    breakpointsSecondary: {
      type: Object,
      default: () => ({
        xs: 2,
        sm: 3,
        md: 4,
        lg: 6,
        xl: 8,
      }),
    },
  },

  async fetch() {
    try {
      this.products = await this.$api('v1').request('oasis/products', {
        params: {
          shuffle: 1,
          limit: this.primaryLimit + this.secondaryLimit,
        },
      })
    } catch (err) {
      console.error(err)
    }
  },

  data: () => ({
    products: [],
  }),

  fetchOnServer: true,

  computed: {
    baseUrl() {
      return process.env.CATALOG_BASE_URL
    },

    productsPrimary() {
      const { products = [], primaryLimit } = this
      return products.slice(0, primaryLimit)
    },

    productsSecondary() {
      const { products = [], primaryLimit } = this
      return products.slice(primaryLimit)
    },

    productPrimaryAttrs() {
      const { xs, md, lg } = this.breakpointsPrimary
      return {
        cols: 12 / xs,
        md: 12 / md,
        lg: 12 / lg,
      }
    },

    productSecondaryAttrs() {
      const { xs, sm, md, lg, xl } = this.breakpointsSecondary

      return {
        cols: 12 / xs,
        sm: 12 / sm,
        md: 12 / md,
        lg: 12 / lg,
        xl: 12 / xl,
      }
    },
  },
}
</script>

<style lang="scss" scoped>
.products-home {
  &__home-primary {
    .v-card--link {
      .v-card__title {
        line-height: 1.7rem !important;
        word-break: break-word;
      }
    }
  }

  &__secondary {
    .v-card--link {
      .v-card__title {
        line-height: 1rem;
      }

      &:hover {
        color: red;
      }
    }
  }

  .product {
    position: relative;
    z-index: 0;

    &__img {
      transition: transform 0.3s ease-in-out;
    }

    &__title {
      display: block;
      word-break: break-word;
    }

    &__price {
      span {
        font-family: $numerals-font-family;
        font-size: 1.5rem;
      }
    }

    &--shadow {
      .v-card {
        position: relative;

        &::before {
          position: absolute;
          z-index: -1;
          bottom: 0;
          left: 0;
          width: 100%;
          height: 100%;
          background: linear-gradient(135deg, #d06383 0%, #c1e782 100%);
          border-radius: 40px;
          content: '';
          filter: blur(25px);
          opacity: 0;
          transform: translateY(30px) scale(0.9);
          transition: all 0.3s ease-in-out;
        }

        &:hover {
          &::before {
            opacity: 1;
          }

          .product__img {
            transform: scale(1.1);
          }
        }
      }
    }
  }
}
</style>
